package scengine;
import java.sql.*;

public class DbManager
{
	    private final String jdbcUrl = "jdbc:mysql://localhost:3306/project";
		private final String dbId = "project";
		private final String dbpass = "dnjsejrjftm";
	
		//Connection conn = null;
        //PreparedStatement pstmt = null;

		public void DbConn()
		{
			//Class.forName("org.gjt.mm.mysql.Driver");
			//conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);
			
		}

		public void ScAiDataInWrite(ScAiData scaiData) throws Exception
		{
			int checkResult = 1;
			Connection conn = null;
			PreparedStatement pstmt = null;
			ResultSet rs = null;	
			try{
			//	DbConn();
				Class.forName("org.gjt.mm.mysql.Driver");
				conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

				for(String str : scaiData.morniterData.serviceName){
					pstmt = conn.prepareStatement("Insert into result_in(serial,process,count,serverip) values(?,?,?,?)");
					pstmt.setLong(1,scaiData.serialNumber);
					pstmt.setString(2,str);
					int result = scaiData.morniterData.hm.get(str);
					pstmt.setInt(3,result);
					pstmt.setString(4,scaiData.morniterData.serverIp);
					pstmt.executeUpdate();

			// 각각의 프로세스 개수 결과를 곱해서 0이되면 스테이터 테이블에 에러 등록. 아니면 1등록 . 에러인경우  Ai에 에러 리턴.
					checkResult *= result ;
				}
				
				pstmt = conn.prepareStatement("select num from result_status where serverip=? and serial=?");
				pstmt.setString(1,scaiData.morniterData.serverIp);
				pstmt.setLong(2,scaiData.serialNumber);
				rs = pstmt.executeQuery();

				rs.last();
				int rsCount = rs.getRow();
				//System.out.println(rsCount);
				//System.out.println(scaiData.serialNumber);
				//System.out.println(scaiData.morniterData.serverIp);
				//System.out.println(checkResult);
				if (rsCount == 0)
				{
					pstmt = conn.prepareStatement("insert into result_status (serial,serverip,result_in) values(?,?,?)");
					pstmt.setLong(1,scaiData.serialNumber);
					pstmt.setString(2,scaiData.morniterData.serverIp);
					if(checkResult != 0){
						checkResult /=checkResult;
					}
					pstmt.setInt(3,checkResult);
					pstmt.executeUpdate();
				} else {
					
					pstmt = conn.prepareStatement("update result_status set result_in=? where serial=? and serverip=?");
					if(checkResult != 0){
						checkResult /=checkResult;
					}
					pstmt.setInt(1,checkResult);
					pstmt.setLong(2,scaiData.serialNumber);
					pstmt.setString(3,scaiData.morniterData.serverIp);
					pstmt.executeUpdate();
				}

				//idle result input
				for (int i=0 ; i< scaiData.morniterData.serverIdleStatus.length;i++)
				{	
					pstmt = conn.prepareStatement("Insert into result_idle(serial,process,status,serverip) values(?,?,?,?)");
                    pstmt.setLong(1,scaiData.serialNumber);
                    pstmt.setString(2,scaiData.morniterData.serverIdleStatus[i][0]);
                    pstmt.setString(3,scaiData.morniterData.serverIdleStatus[i][1]);
                    pstmt.setString(4,scaiData.morniterData.serverIp);
					pstmt.executeUpdate();
				}
					
			}catch(Exception e){
				System.out.println("DbManager: ScAiDataInWrite : " +  e.getMessage());
			}finally{
				 if (pstmt != null) try { pstmt.close(); } catch(SQLException ex) {}
				 if (conn != null) try { conn.close(); } catch(SQLException ex) {}
			}
		}
								 
	void ConnFailWriteIn(ScAiData scaiData)
	{
		
		Connection conn = null;
        PreparedStatement pstmt = null;
		ResultSet rs = null;

		try{
	            //  DbConn();
	        Class.forName("org.gjt.mm.mysql.Driver");
			conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);
			
			pstmt = conn.prepareStatement("insert into result_in (serial,process,count,serverip) values (?,?,?,?)");
			pstmt.setLong(1,scaiData.serialNumber);
			pstmt.setString(2,"conn");
			pstmt.setInt(3,0);
			pstmt.setString(4,scaiData.morniterData.serverIp);
			pstmt.executeUpdate();
			
			pstmt = conn.prepareStatement("select num from result_status where serverip=? and serial=?");
            pstmt.setString(1,scaiData.morniterData.serverIp);
            pstmt.setLong(2,scaiData.serialNumber);
            rs = pstmt.executeQuery();
            rs.last();
            int rsCount = rs.getRow();
            if (rsCount == 0)
            {
               pstmt = conn.prepareStatement("insert into result_status (serial,serverip,result_in) values (?,?,?)");
                pstmt.setLong(1,scaiData.serialNumber);
                pstmt.setString(2,scaiData.morniterData.serverIp);
                pstmt.setInt(3,0);
                pstmt.executeUpdate();
            } else {
                pstmt = conn.prepareStatement("update result_status set result_in=? where serial=? and serverip=?");
                pstmt.setInt(1,0);
                pstmt.setLong(2,scaiData.serialNumber);
                pstmt.setString(3,scaiData.morniterData.serverIp);
                pstmt.executeUpdate();
            }
	
		}catch(Exception e){
	        //System.out.println(e.getMessage());
			e.printStackTrace();
	    }finally{
			if (pstmt != null) try { pstmt.close(); } catch(SQLException ex) {}
			if (conn != null) try { conn.close(); } catch(SQLException ex) {}
	    }
	}
	public void  OuterDataWriter(OuterData outerData)
	{
		
		Connection conn = null;
	    PreparedStatement pstmt = null;
	    ResultSet rs = null;
		
		//System.out.println("OuterDataWriter In");
		
		try{
	        //  DbConn();
	        Class.forName("org.gjt.mm.mysql.Driver");
	        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);
			int resultFinal=1;
			//System.out.println(resultFinal);	
			for(int i=0;i<outerData.serviceData.length ;i++)
			{
				pstmt = conn.prepareStatement("insert into result_out (serial,process,status,serverip) values (?,?,?,?)");
				pstmt.setLong(1,outerData.serialNumber);
				pstmt.setString(2,outerData.serviceData[i][0]);
				pstmt.setInt(3,Integer.parseInt(outerData.serviceData[i][3]));
				pstmt.setString(4,outerData.serverIp);
				pstmt.executeUpdate();
				resultFinal *= Integer.parseInt(outerData.serviceData[i][3]);
			//	System.out.println(resultFinal);
			}

			pstmt = conn.prepareStatement("select num from result_status where serverip=? and serial=?");
			pstmt.setString(1,outerData.serverIp);
			pstmt.setLong(2,outerData.serialNumber);
			rs = pstmt.executeQuery();
			rs.last();
			int rsCount = rs.getRow();
			if (rsCount == 0)
            {
           		pstmt = conn.prepareStatement("insert into result_status (serial,serverip,result_out) values (?,?,?)");
               	pstmt.setLong(1,outerData.serialNumber);
               	pstmt.setString(2,outerData.serverIp);
              	pstmt.setInt(3,resultFinal);
               	pstmt.executeUpdate();
            } else {
               	pstmt = conn.prepareStatement("update result_status set result_out=? where serial=? and serverip=?");
               	pstmt.setInt(1,resultFinal);
               	pstmt.setLong(2,outerData.serialNumber);
               	pstmt.setString(3,outerData.serverIp);
               	pstmt.executeUpdate();
            }
		}catch(Exception e){
			System.out.println("DbManager - OuterDataWriter:" + e.getMessage());
		}finally{
			if (pstmt != null) try { pstmt.close(); } catch(SQLException ex) {}
			if (conn != null) try { conn.close(); } catch(SQLException ex) {}
		}
	}
	
	public String DaemonControl(String DaemonName,String DaemonControl)
	{
		Connection conn = null;
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		
		String serviceName = null;
		String serviceScript = null;
		String returnScript = null;
		try{
			//  DbConn();
			Class.forName("org.gjt.mm.mysql.Driver");
			conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);
			pstmt = conn.prepareStatement("select initscript,inittype from service where name=?");
			pstmt.setString(1,DaemonName);
			rs = pstmt.executeQuery();
			
			rs.next();
			
			serviceName=rs.getString("initscript");
			serviceScript=rs.getString("inittype");
			
			
			
		}catch(Exception e){
            e.printStackTrace();
        }finally{
            if (pstmt != null) try { pstmt.close(); } catch(SQLException ex) {}
            if (conn != null) try { conn.close(); } catch(SQLException ex) {}
        }

		if (serviceScript.equals("chkconfig")){
				returnScript = serviceName +" " +  DaemonControl;
		}else {
			returnScript = serviceName +" &";
		}
				
		
		return returnScript;
		
	}
	StringBuffer FireRull(String serverIp)
	{
		Connection conn = null;
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		StringBuffer tempRull = new StringBuffer();;
		String tempLine="-A RH-Firewall-1-INPUT";
		try{
			Class.forName("org.gjt.mm.mysql.Driver");
			conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);
			pstmt = conn.prepareStatement("select proto,s_ip,s_port,d_port from firewall_deny where host_ip=?");
			pstmt.setString(1,serverIp);
			rs = pstmt.executeQuery();
			while(rs.next())
			{
				String proto = rs.getString("proto");
				String s_ip = rs.getString("s_ip");
				String s_port = rs.getString("s_port");
				String d_port = rs.getString("d_port");

				if(proto != null){
					tempLine += " -p " + proto ;
				}
				if(s_ip != null){
					tempLine += " -s " + s_ip ;
				}
				if(s_port != null){
					tempLine += " --sport " + s_port;
				}
				if(d_port != null){
					tempLine += " --dport " + d_port;
				}
				tempRull.append(tempLine);
				tempRull.append(" -j DROP \n");
			}
			tempRull.append("-A RH-Firewall-1-INPUT -m state --state ESTABLISHED,RELATED -j ACCEPT \n");
			pstmt = conn.prepareStatement("select proto,s_ip,s_port,d_port from firewall_accept where host_ip=?");
			pstmt.setString(1,serverIp);
			rs = pstmt.executeQuery();
			while(rs.next())
			{
				String proto = rs.getString("proto");
                String s_ip = rs.getString("s_ip");
                String s_port = rs.getString("s_port");
                String d_port = rs.getString("d_port");
				tempLine = "-A RH-Firewall-1-INPUT -m state --state NEW -m ";

                if(proto != null){
                    tempLine += proto + " -p " + proto ;
                }
                if(s_ip != null){
                    tempLine += " -s " + s_ip ;
                }
                if(s_port != null){
                    tempLine += " --sport " + s_port;
                }
                if(d_port != null){
                    tempLine += " --dport " + d_port;
                }
                tempRull.append(tempLine);
                tempRull.append(" -j ACCEPT \n");
			}
		}catch(Exception e){
			e.printStackTrace();
		}finally{
			try{
				if(rs != null) try { rs.close();} catch(SQLException ex){}
				if(pstmt != null) try { pstmt.close();} catch(SQLException ex){}
				if(conn != null) try { conn.close();} catch(SQLException ex){}
			}catch(Exception e){
				e.printStackTrace();
			}
		}
			
		return(tempRull);
	
	}

}
