package scengine;
import java.util.*;
import java.net.*;
import java.lang.*;
import java.io.*;



public class PerChildMorniter extends Thread
{
	ScAiData scaiData = null; 
	
	public PerChildMorniter(ScAiData scaiData)
	{
		this.scaiData = scaiData;
	}

	public void run()
	{
		Object obj;
		Socket socket =null;
		
		System.out.println("PerChild In " + scaiData.morniterData.serverIp);	
		try{
				
			socket = new Socket(scaiData.morniterData.serverIp,9000);

//			System.out.println("Perchild Socket new ok " + scaiData.morniterData.serverIp);
			
			ObjectOutputStream out = new ObjectOutputStream(socket.getOutputStream());
			ObjectInputStream in = new ObjectInputStream(socket.getInputStream());

//			System.out.println("PerChildMorniter: " + scaiData.morniterData.serverIp);
			out.writeObject(scaiData);
//			System.out.println("PerChildMorniter: "+ scaiData.morniterData.serverIp + "write ok");
			obj = in.readObject();

			scaiData = (ScAiData) obj;
			
		//	for(String str : scaiData.morniterData.serviceName)
	//		{
	//			System.out.println(str + " " + scaiData.morniterData.hm.get(str));
	//		}
			
	//		System.out.println("PerChildMornter");
			DbManager dbManager = new DbManager();
			dbManager.ScAiDataInWrite(scaiData);
			
		}catch(ConnectException ce){
			DbManager dbManager = new DbManager();
			dbManager.ConnFailWriteIn(scaiData);
				
			System.out.println("connect fail");
		}catch(Exception e){
			System.out.println("Perchild Morniter:" + e.getMessage());
			e.printStackTrace();
			
		System.out.println("PerChild In " + scaiData.morniterData.serverIp);	
		}finally{
			try{
				socket.close();
			}catch(Exception e){
				e.printStackTrace();
			}
		}

	}

		
			

}
