package scengine;
import java.io.*;
import java.util.*;
import java.net.*;
import java.lang.Thread;
import java.sql.*;

public class ScOuter //클라이언트들의 내부 프로세스에서 체크 한 결과를 리시브. & 
{
	ArrayList<OuterData> childOuterLists;
	private final String jdbcUrl = "jdbc:mysql://localhost:3306/project";
	private final String dbId = "project";
	private final String dbpass = "dnjsejrjftm";
	
	public static void main(String args[])
	{
		new ScOuter().go();
		
	}
	
	public void  go()
	{
		DaemonInitialize();

		ServerSocket serverSocket = null;
		try{
			serverSocket = new ServerSocket(9002);
			
			while(true){
				Socket socket = serverSocket.accept();
				
				Thread morniterOuterThread = new MorniterOuterThread(socket,childOuterLists);

				morniterOuterThread.start();
			}
		}catch(Exception e){
			System.out.println(e.getMessage());
		}
	}
	
	public void DaemonInitialize()
	{
		//System.out.println("Daemon init start");
		childOuterLists = new ArrayList<OuterData>();
				
		Connection conn = null;
		PreparedStatement pstmt = null;
		ResultSet rs = null;
			
		try{
			
			Class.forName("org.gjt.mm.mysql.Driver");
            conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

            pstmt = conn.prepareStatement("select ip from server where status_check=1");
            rs = pstmt.executeQuery();

			
			while(rs.next())
			{
				String serverIp=rs.getString("ip");
				ResultSet rss = null;

				//System.out.println("ScOuter " +serverIp + " "+ rs.getRow());

				//ip 별로 서비스 확인
				try{
					pstmt = conn.prepareStatement("select service.name,service.protocol,service.port from server,service,ss_info where server.status_check=1 And server.ip=? AND ss_info.server = server.num AND ss_info.service=service.num AND service.port IS NOT NULL AND service.port IS NOT NULL order by server.ip");
					pstmt.setString(1,serverIp);
					rss=pstmt.executeQuery();
				
					// 서비스 전체개수 체크 
					//System.out.println("ScOuter Query exec");	
					rss.last();
					int serviceCount = 0;
					//System.out.println(serverIp);
					serviceCount = rss.getRow();
					//System.out.println(serviceCount);
					if (serviceCount == 0)
					{
						continue;
					}
					rss.beforeFirst();
					//클래스 호출 	
					OuterData outerData = new OuterData(serverIp,serviceCount);
				
					//클래스에 내장배열에 서비스  등록
					int ddd = 0; // serviceName 배열의 인덱스

					// System.out.println("Scouter middle");
					while(rss.next())
					{
						String serviceName=rss.getString("service.name");
						String serviceProtocol=rss.getString("service.protocol");
						String servicePort=rss.getString("service.port");
						
						if(serviceProtocol.equals(null)  || servicePort.equals(null)){
							continue;
						}
						
						String serviceStatus="0";		
						outerData.serviceData[ddd][0]=serviceName;
						outerData.serviceData[ddd][1]=serviceProtocol;
						outerData.serviceData[ddd][2]=servicePort;
						outerData.serviceData[ddd][3]=serviceStatus;
						
						
						ddd++;

					}
					childOuterLists.add(outerData);
				//	System.out.println("ScOuter testPoint");	
				//	for(int i=0 ;i<outerData.serviceData.length;i++)
			//		{
			//			System.out.println(outerData.serviceData[i][0]);
		//				System.out.println(outerData.serviceData[i][1]);
		//				System.out.println(outerData.serviceData[i][2]);
	//					System.out.println(outerData.serviceData[i][3]);
	//				}

				}catch(Exception e){
					e.printStackTrace();
				}finally{
					if(rss != null) try {rss.close();} catch(SQLException ex){}
				}


					
					
			}
			
		}catch(Exception e){
			e.printStackTrace();
		}finally{
			if(rs != null) try { rs.close();} catch(SQLException ex){}
			if(pstmt != null) try { pstmt.close();} catch(SQLException ex){}
			if(conn != null) try { conn.close();} catch(SQLException ex){}
		}
		


		/*
		
		try{
			String bbb="127.0.0.1";
			Socket socket = new Socket(bbb,9000);
			ObjectOutputStream out = new ObjectOutputStream(socket.getOutputStream());
			ObjectInputStream in = new ObjectInputStream(socket.getInputStream());
			
			//String aaa="aaaaaaa";
			DoSetData aaa = new DoSetData();
			aaa.daemonType= "Set";
			
			out.writeObject(aaa);
			//out.writeObject(null);	
		}catch(Exception e){
			System.out.println(e.getMessage());
		}
		*/

		//System.out.println("Outer initialize.... OK");

	}

}




