web_hostadd_run(){
#	local DOMAIN_NAME=${DOMAIN%%.*}
    local WSITE="www.$DOMAIN"
#local HOME_DIR="$WEB_DIR/$DOMAIN_NAME"
    local HOME_DIR="$WEB_DIR/$DOMAIN"
    local LOG_FILE="$LOG_DIR/$DOMAIN/access_log"
		
	if [ -d $HOME_DIR ]; then
		echo "$DOMAIN is exists"
			exit 10;
	fi
	
	mkdir $HOME_DIR
	mkdir $LOG_DIR/$DOMAIN
		
    sed -e "s;WSITE;${WSITE};g" -e "s;HOME_DIR;${HOME_DIR};g" -e "s;DOMAIN;${DOMAIN};g" -e "s;IP_ADDR;${IP_ADDR};g" -e "s;LOG_FILE;${LOG_FILE};g" <${HTTPD_DEFAULT} >>${HTTPD_CONF}
	return 0;
}
web_hostdel_run(){
	
	
    local NOW_LINE=$(grep -n "ServerName www.$DOMAIN" $HTTPD_CONF)

	if [ ! -d $HOME_DIR ]; then
		echo "$DOMAIN is noet exists"
			exit 10
	fi

	rm -rf $WEB_DIR/$DOMAIN 
	rm -rf $LOG_DIR/$DOMAIN
			
		
    if [ "$NOW_LINE" != "" ]; then

        NOW_LINE=${NOW_LINE%%:*}
        NOW_LINE=`expr $NOW_LINE - 1`

        END=`sed -e 1,${NOW_LINE}d $HTTPD_CONF | grep -n "</VirtualHost>" | awk -F: '{print $1}'`

        for TMP in $END
        do
            END_LINE=$TMP
            break
        done

        END_LINE=`expr $NOW_LINE + $END_LINE `

        sed -e $NOW_LINE,${END_LINE}d <$HTTPD_CONF > ${ROOT_DIR}/HTTPD_CONF.txt
        if ! cp ${ROOT_DIR}/HTTPD_CONF.txt $HTTPD_CONF ; then
            rm -f ${HTTPD_SWP_FILE}
            exit 31
        fi
        rm -f ${ROOT_DIR}/HTTPD_CONF.txt
    fi
	return 0;
}

