package scengine;

import java.util.*;
import java.io.*;
import java.lang.*;
import java.net.*;

public class FireWall
{
	public int RunFire(String serverIp)
	{
		Socket clientSocket = null;
		Object obj=null;
		StringBuffer fireRull = new StringBuffer();
		fireRull.append("# Firewall configuration written by system-config-securitylevel\n# Manual customization of this file is not recommended.\n*filter\n:INPUT ACCEPT [0:0]\n:FORWARD ACCEPT [0:0]\n:OUTPUT ACCEPT [0:0]\n:RH-Firewall-1-INPUT - [0:0]\n-A INPUT -j RH-Firewall-1-INPUT\n-A FORWARD -j RH-Firewall-1-INPUT\n-A RH-Firewall-1-INPUT -i lo -j ACCEPT\n-A RH-Firewall-1-INPUT -p icmp --icmp-type any -j ACCEPT\n-A RH-Firewall-1-INPUT -p 50 -j ACCEPT\n-A RH-Firewall-1-INPUT -p 51 -j ACCEPT\n-A RH-Firewall-1-INPUT -p udp --dport 5353 -d 224.0.0.251 -j ACCEPT\n-A RH-Firewall-1-INPUT -p udp -m udp --dport 631 -j ACCEPT\n-A RH-Firewall-1-INPUT -p tcp -m tcp --dport 631 -j ACCEPT\n");

		FireData fireData = new FireData();
		
		fireData.serverIp = serverIp;

		DbManager dM = new DbManager();
		
		fireRull.append(dM.FireRull(serverIp));
		fireRull.append("-A RH-Firewall-1-INPUT -j REJECT --reject-with icmp-host-prohibited\nCOMMIT\n");

		fireData.fireRull = new String(fireRull);
		//fireData.fireRull = "fireRull";
//		System.out.println(fireData.fireRull);
		
		try{
			System.out.println(fireData.serverIp);
			clientSocket = new Socket(fireData.serverIp,9000);
			ObjectOutputStream clientOut = new ObjectOutputStream(clientSocket.getOutputStream());
			ObjectInputStream clientIn = new ObjectInputStream(clientSocket.getInputStream());

			clientOut.writeObject(fireData);
		//	System.out.println("fireData write");
			obj = clientIn.readObject();

			fireData = (FireData)obj;
		}catch(Exception e){
			e.printStackTrace();
		}finally{
			try{
				clientSocket.close();
			}catch(Exception e){
				e.printStackTrace();
			}
		}
		return fireData.resultNum;
	}
}
