package scengine;

import java.util.*;
import java.io.*;
import java.net.*;
import java.lang.*;

public class AiTimerThread extends Thread
{
	int sleepTime = 300000;
	public AiErrorData aiErrorData;
	
	public void run()
	{
		ScAiData scaiData = new ScAiData();
		scaiData.checkType= "Morniter";
		scaiData.dataType="Morniter";
		Socket outchecksocket = null;
		Socket inchecksocket = null;
		ObjectOutputStream outcheck = null;	
		ObjectOutputStream incheck = null;	
		try{
			while(true)
			{	
				scaiData.serialNumber = (new Date().getTime()) /60000;
				
				try{
					outchecksocket = new Socket("127.0.0.1",9002);
					inchecksocket = new Socket("127.0.0.1",9001);
					outcheck = new ObjectOutputStream(outchecksocket.getOutputStream());
					incheck = new ObjectOutputStream(inchecksocket.getOutputStream());
					//System.out.println("Ai Out  write");
					incheck.writeObject(scaiData);
					outcheck.writeObject(scaiData);
				}catch(Exception e){
					System.out.println(e.getMessage());
				}finally{
					try{
						incheck.close();
						outcheck.close();
						inchecksocket.close();
						outchecksocket.close();
					}catch(Exception e){
					System.out.println(e.getMessage());
					}
				}
				
				if (aiErrorData.isError == 0){
					sleepTime = 300000;
				}else {
					sleepTime = 60000;
				}

				sleep(sleepTime);
			}
		}catch(Exception e){
			System.out.println(e.getMessage());
		}
	}
}


	

