package scengine;
import java.io.*;
import java.util.*;
import java.net.*;
import java.lang.*;


public class CommandThread extends Thread
{
	Socket serverSocket,clientSocket;

	public CommandThread(Socket socket)
	{
		this.serverSocket = socket;
	}

	public void run()
	{
		Object obj = null;

		try{

			ObjectInputStream serverIn = new ObjectInputStream(serverSocket.getInputStream());
			ObjectOutputStream serverOut = new ObjectOutputStream(serverSocket.getOutputStream());

			obj = serverIn.readObject();
			ProcessData processData = (ProcessData)obj;

			Socket clientSocket = new Socket(processData.serverIp,9000);
			
			ObjectOutputStream clientOut = new ObjectOutputStream(clientSocket.getOutputStream());
			ObjectInputStream clientIn = new ObjectInputStream(clientSocket.getInputStream());

			clientOut.writeObject(processData);
			obj = clientIn.readObject();
			
			processData = (ProcessData)obj;
			System.out.println(processData.resultCommand);
			serverOut.writeObject(processData);
			
			
			//System.out.println(processData.checkType);
			//System.out.println(processData.resultCommand);
			//System.out.println("processData Execute End");
			//System.out.println("processData exitValue: " + processData.resultNum);
		}catch(Exception e){
			//System.out.println(e.getMessage());
			e.printStackTrace();
		}finally{
			try{
				//clientIn.close();
				//clientOut.close();
				//serverIn.close();
				//serverOut.close();
				clientSocket.close();
				serverSocket.close();
		//		serverSocket.close();
				System.out.println("CommandThread End");
			}catch(Exception e){
	//			System.out.println(e.getMessage());
			}
		}
	}
}
		
			
