package scengine;
import java.io.*;
import java.util.*;
import java.net.*;
import java.lang.*;


public class MorniterOuterThread extends Thread
{
    Socket socket;
	ArrayList<OuterData> childOuterLists;

    public MorniterOuterThread(Socket socket,ArrayList<OuterData> childOuterLists)
    {
        this.socket = socket;
		this.childOuterLists = childOuterLists;
    }

    public void run()
    {
        Object obj = null;
        
		try{
			//Ai로 부터 ScAi데이터 수신	
			ObjectInputStream serverin = new ObjectInputStream(socket.getInputStream());

			//System.out.println("MorniterOuterThread start");
			obj = serverin.readObject();
			ScAiData scaiData = (ScAiData)obj;
		
			//System.out.println("scaiDAta readin");
			
			Iterator it = childOuterLists.iterator();
			while(it.hasNext())
			{
				
				OuterData outerData = (OuterData)it.next();
			
				outerData.serialNumber = scaiData.serialNumber;
				outerData.checkType = "MorniterOuter"; 
				outerData.dataType = scaiData.dataType;
				//outerData.morniterData = morniterData;
					
			//	System.out.println("MorniterThread: " + outerData.serverIp);

				Thread thread = new PerChildOuter(outerData);
				thread.start();
				//System.out.println("MorniterThread thread start");
			}
			
		
		}catch(Exception e ){
			System.out.println(e.getMessage());
		}finally{
			try{
				socket.close();
			}catch(Exception e){}
		}

	}
}

