package scengine;
import java.io.*;
import java.util.*;
import java.net.*;
import java.lang.*;


public class MorniterThread extends Thread
{
    Socket socket;
	ArrayList<MorniterData> childMorniterLists;

    public MorniterThread(Socket socket,ArrayList<MorniterData> childMorniterLists)
    {
        this.socket = socket;
		this.childMorniterLists = childMorniterLists;
    }

    public void run()
    {
        Object obj = null;
        
		try{
			
		//	ObjectOutputStream serverout = new ObjectOutputStream(socket.getOutputStream());
			ObjectInputStream serverin = new ObjectInputStream(socket.getInputStream());

			obj = serverin.readObject();
			ScAiData scaiData = (ScAiData)obj;
				
//			System.out.println("ScAiData recive");		
//			System.out.println(scaiData.checkType);		
			
			Iterator it = childMorniterLists.iterator();
			while(it.hasNext())
			{
				ScAiData scaiData2 = new ScAiData();
				scaiData2.serialNumber = scaiData.serialNumber;
				scaiData2.checkType = "MorniterIn"; 
				scaiData2.dataType = scaiData.dataType;
					
				MorniterData morniterData = (MorniterData)it.next();
				scaiData2.morniterData = morniterData;
					
				System.out.println("MorniterThread: " + scaiData2.morniterData.serverIp);

				Thread thread = new PerChildMorniter(scaiData2);
				thread.start();
				//System.out.println("MorniterThread thread start");
			}
			
		
		}catch(Exception e ){
			System.out.println(e.getMessage());
		}finally{
			try{
				socket.close();
			}catch(Exception e){}
		}

	}
}

