package scengine;
import java.io.*;
import java.util.*;
import java.net.*;
import java.lang.Thread;
import java.sql.*;

public class ScMorniter //클라이언트들의 내부 프로세스에서 체크 한 결과를 리시브. & 
{
	ArrayList<MorniterData> childMorniterLists;
	private final String jdbcUrl = "jdbc:mysql://localhost:3306/project";
	private final String dbId = "project";
	private final String dbpass = "dnjsejrjftm";
	
	public static void main(String args[])
	{
		new ScMorniter().go();
		
	}
	
	public void  go()
	{
		DaemonInitialize();




		ServerSocket serverSocket = null;
		try{
			serverSocket = new ServerSocket(9001);
			
			while(true){
				Socket socket = serverSocket.accept();

				//System.out.println("Ai socket accept ok");
				
				Thread morniterThread = new MorniterThread(socket,childMorniterLists);

				morniterThread.start();
			}
		}catch(Exception e){
			System.out.println(e.getMessage());
		}
			
		
/*		Iterator it = childMorniterLists.iterator();
		while(it.hasNext()){
			try{
				MorniterData MD = (MorniterData)it.next();
				System.out.println(MD.serverIp);
			}catch(Exception e){
			}
		}
*/		

	}
	
	public void DaemonInitialize()
	{
		childMorniterLists = new ArrayList<MorniterData>();
				
		Connection conn = null;
		PreparedStatement pstmt = null;
		ResultSet rs = null;
			
		try{
			
			Class.forName("org.gjt.mm.mysql.Driver");
            conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

            pstmt = conn.prepareStatement("select ip from server where status_check=1");
            rs = pstmt.executeQuery();

			
			while(rs.next())
			{
				String serverIp=rs.getString("ip");
				ResultSet rss = null;

				//ip 별로 서비스 확인
				try{
					pstmt = conn.prepareStatement("select service.name from server,service,ss_info where server.status_check=1 And server.ip=? AND ss_info.server = server.num AND ss_info.service=service.num order by server.ip");
					pstmt.setString(1,serverIp);
					rss=pstmt.executeQuery();
				
					// 서비스 전체개수 체크 
			//		ResultSetMetaData rsMetaData = rss.getMetaData();
			//		int serviceCount = rsMetaData.getColumnCount();
					//System.out.println("aaa");
					
					rss.last();
					int serviceCount = 0;
					serviceCount = rss.getRow();
					if (serviceCount == 0)
					{
						continue;
					}
					rss.beforeFirst();
					//System.out.println(serverIp+" "+ "serviceCount=" + serviceCount);	
				
					//클래스 호출 	
					MorniterData morniterData = new MorniterData(serverIp,serviceCount);
				
					//클래스에 내장배열에 서비스  등록
					int ddd = 0; // serviceName 배열의 인덱스
					while(rss.next())
					{
						String serviceName=rss.getString("service.name");
						
						morniterData.serviceName[ddd]=serviceName;
						ddd++;

					}
					pstmt = conn.prepareStatement("select idle.name from server,idle,si_info where server.status_check=1 And server.ip=? AND si_info.server = server.num AND si_info.idle=idle.num order by idle.num");
					pstmt.setString(1,serverIp);
					rss=pstmt.executeQuery();
					rss.last();
					serviceCount = rss.getRow();	
					if (serviceCount == 0)
					{
						continue;
					}
					rss.beforeFirst();
					ddd=0;
					morniterData.serverIdleStatus = new String[serviceCount][3];
					while(rss.next())
					{
						String idleName=rss.getString("idle.name");
						morniterData.serverIdleStatus[ddd][0] = idleName;
						ddd++;
					}
						
					childMorniterLists.add(morniterData);	


				}catch(Exception e){
					e.printStackTrace();
				}finally{
					if(rss != null) try {rss.close();} catch(SQLException ex){}
				}


					
					
			}
			
		}catch(Exception e){
			e.printStackTrace();
		}finally{
			if(rs != null) try { rs.close();} catch(SQLException ex){}
			if(pstmt != null) try { pstmt.close();} catch(SQLException ex){}
			if(conn != null) try { conn.close();} catch(SQLException ex){}
		}
		


		/*
		
		try{
			String bbb="127.0.0.1";
			Socket socket = new Socket(bbb,9000);
			ObjectOutputStream out = new ObjectOutputStream(socket.getOutputStream());
			ObjectInputStream in = new ObjectInputStream(socket.getInputStream());
			
			//String aaa="aaaaaaa";
			DoSetData aaa = new DoSetData();
			aaa.daemonType= "Set";
			
			out.writeObject(aaa);
			//out.writeObject(null);	
		}catch(Exception e){
			System.out.println(e.getMessage());
		}
		*/

		System.out.println("Morniter initialize.... OK");

	}

}






	
	/*
	public void Add(String name,int count)
	{
		hm.put(name,count);
		

	}
	*/
	
/*		
class DoSetData implements Serializable
{
	String setOption = null;
	String doResult = null;
	String daemonType = null;	
		
	public String toString()
	{
		return daemonType;
	}
}
*/


		
