package admin;

import java.sql.*;
import java.util.*;

public class AdminDBBean
{	
	private final String jdbcUrl = "jdbc:mysql://localhost:3306/project";
	private final String dbId = "project";
        private final String dbpass = "dnjsejrjftm";
				       

	
	//userCheck
	 public int userCheck(String id, String passwd) throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;
                ResultSet rs = null;
                String dbpasswd = "";
                int x = -1;

                try
                {
                        Class.forName("org.gjt.mm.mysql.Driver");
                	conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

                        pstmt = conn.prepareStatement("select a_passwd from admin  where a_id = ?");
                        pstmt.setString (1,id);
                        rs = pstmt.executeQuery();

                        if(rs.next())
                        {
                                dbpasswd = rs.getString("a_passwd");
                                if(dbpasswd.equals(passwd))
                                {
                                        x = 1;
                                }
                                else
                                {
                                        x = 0;
                                }
                        }
                        else
                        {
                                x = -1;
                        }
                }
                catch(Exception ex)
                {
                   ex.printStackTrace();
                }
                finally
                {
                   if(rs != null) try { rs.close();} catch(SQLException ex){}
                   if(pstmt != null) try { pstmt.close();} catch(SQLException ex){}
                   if(conn != null) try { conn.close();} catch(SQLException ex){}
                }

                return x;
        }
	//member count
	public int getArticleCount() throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;
                ResultSet rs = null;

                int x = 0;

                try
                {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

                        pstmt = conn.prepareStatement("select count(*) from member");
                        rs = pstmt.executeQuery();

                        if(rs.next())
                        {
                                x = rs.getInt(1);
                        }
                }

                catch(Exception ex)
                {
                ex.printStackTrace();
                }

                finally
                {
                        if(rs != null) try { rs.close();} catch(SQLException ex){}
                        if(pstmt != null) try { pstmt.close();} catch(SQLException ex){}
                        if(conn != null) try { conn.close();} catch(SQLException ex){}
                }
                return x;
        }

	//member list
 	public List getArticles(int start, int end)throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;
                ResultSet rs = null;
		List<AdminDataBean> articleList = null;
 
                 try
               {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

          pstmt = conn.prepareStatement("select * from member  order by id asc limit ?,?");
                        
                        pstmt.setInt(1, start-1);
                        pstmt.setInt(2, end);
                        rs = pstmt.executeQuery();


			if(rs.next())
                        {
				articleList = new ArrayList<AdminDataBean>(end);
                                do
                                {
                                        AdminDataBean article = new AdminDataBean();
			  	
						article.setId(rs.getString("id"));
				  		article.setPasswd(rs.getString("passwd"));
                  				article.setM_name(rs.getString("m_name"));
                  				article.setPhone(rs.getString("phone"));
                  				article.setEmail(rs.getString("email"));
			      			article.setTo_date(rs.getTimestamp("to_date"));
						article.setCheck_adm(rs.getInt("check_adm"));
               				
					    	articleList.add(article);
                   
                } while (rs.next());
            }
        } catch (Exception ex) {
            ex.printStackTrace();
        } finally {if (rs != null) try {rs.close();} catch (SQLException ex) {}
            if (pstmt != null)try {pstmt.close();} catch (SQLException ex) {}
            if (conn != null) try { conn.close(); } catch (SQLException ex) {}
        }
        return articleList;
    }


	//server count	
	  public int getServerCount() throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;
                ResultSet rs = null;

                int x = 0;

                try
                {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

                        pstmt = conn.prepareStatement("select count(*) from server");
                        rs = pstmt.executeQuery();

                        if(rs.next())
                        {
                                x = rs.getInt(1);
                        }
                }

                catch(Exception ex)
                {
                ex.printStackTrace();
                }

                finally
                {
                        if(rs != null) try { rs.close();} catch(SQLException ex){}
                        if(pstmt != null) try { pstmt.close();} catch(SQLException ex){}
                        if(conn != null) try { conn.close();} catch(SQLException ex){}
                }
                return x;
        }


	//server select
	public List getArticleServer(int start, int end)throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;
                ResultSet rs = null;
                List<AdminDataBean> articleList = null;

                 try
               {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

          pstmt = conn.prepareStatement("select * from server order by num asc limit ?,?");

                        pstmt.setInt(1, start-1);
                        pstmt.setInt(2, end);
                        rs = pstmt.executeQuery();


                        if(rs.next())
                        {
                                articleList = new ArrayList<AdminDataBean>(end);
                                do
                                {
                                        AdminDataBean article = new AdminDataBean();
						
						article.setNum(rs.getInt("num"));	
                                                article.setIp(rs.getString("ip"));
                                                article.setStatus_check(rs.getInt("status_check"));
                                                article.setRpass(rs.getString("rpass"));
                                                article.setName(rs.getString("name"));
                                             
                                                articleList.add(article);

                } while (rs.next());
            }
        } catch (Exception ex) {
            ex.printStackTrace();
        } finally {if (rs != null) try {rs.close();} catch (SQLException ex) {}
            if (pstmt != null)try {pstmt.close();} catch (SQLException ex) {}
            if (conn != null) try { conn.close(); } catch (SQLException ex) {}
        }
        return articleList;
    }
	
  
	//server update search
	public AdminDataBean updateGetServer(int num)throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;
                ResultSet rs = null;
                AdminDataBean article = null;

                try
                {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

                        pstmt = conn.prepareStatement("select * from server where num = ?");
                        pstmt.setInt(1,num);
                        rs = pstmt.executeQuery();

                        if(rs.next())
                        {
                                article = new AdminDataBean();
                                article.setNum(rs.getInt("num"));
                                article.setIp(rs.getString("ip"));
                                article.setStatus_check(rs.getInt("status_check"));
                                article.setRpass(rs.getString("rpass"));
                                article.setName(rs.getString("name"));
                        }
                }

                catch(Exception ex)
                {
                ex.printStackTrace();
                }

                finally
                {
                        if(rs != null) try { rs.close();} catch(SQLException ex){}
                        if(pstmt != null) try { pstmt.close();} catch(SQLException ex){}
                        if(conn != null) try { conn.close();} catch(SQLException ex){}
                }
                return article;
        }
	
	//update server
	public void  updateServer(AdminDataBean article)throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;

                try
                {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

pstmt = conn.prepareStatement("update server set ip=?,status_check=?,rpass=?,name=? where num=?");
                pstmt.setString(1,article.getIp());
                pstmt.setInt(2,article.getStatus_check());
                pstmt.setString(3,article.getRpass());
                pstmt.setString(4,article.getName());
                pstmt.setInt(5,article.getNum());
                pstmt.executeUpdate();
                }
                catch(Exception ex)
                {
                ex.printStackTrace();
                }

                finally
                {
                        if(pstmt != null) try { pstmt.close();} catch(SQLException ex){}
                        if(conn != null) try { conn.close();} catch(SQLException ex){}
                }
        }

	//delete server
	public void deleteServer(int num)throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;

                try
                {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);
                        pstmt = conn.prepareStatement("delete from server where num=?");
                        pstmt.setInt(1,num);
                        pstmt.executeUpdate();
                }
                catch(Exception ex)
                {
                ex.printStackTrace();
                }

                finally
                {
                        if(pstmt != null) try { pstmt.close();} catch(SQLException ex){}
                        if(conn != null) try { conn.close();} catch(SQLException ex){}
                }
        }

	//insert Server
	public void insertServer(AdminDataBean member) throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;

                try
                {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

pstmt = conn.prepareStatement("insert into server(ip,status_check,rpass,namE) values (?,?,?,?)");

                        pstmt.setString(1,member.getIp());
                        pstmt.setInt(2,member.getStatus_check());
                        pstmt.setString(3,member.getRpass());
                        pstmt.setString(4,member.getName());
                        pstmt.executeUpdate();
                }
                catch(Exception ex)
                {
                ex.printStackTrace();
                }
                finally
                {
                        if(pstmt != null) try { pstmt.close();} catch(SQLException ex){}
                        if(conn != null) try { conn.close();} catch(SQLException ex){}
                }
        }
	
	//member search
	
       public AdminDataBean GetMember(String id)throws Exception
        {

                Connection conn = null;
                PreparedStatement pstmt = null;
                ResultSet rs = null;
                AdminDataBean member=null;

        try
        {

                Class.forName("org.gjt.mm.mysql.Driver");
                conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

                pstmt = conn.prepareStatement("select * from member where id = ?");
                pstmt.setString(1, id);
                rs = pstmt.executeQuery();

                if (rs.next()) {
                        member = new AdminDataBean();
                        member.setId(rs.getString("id"));
                        member.setPasswd(rs.getString("passwd"));
                        member.setM_name(rs.getString("m_name"));
                        member.setEmail(rs.getString("email"));
                        member.setPhone(rs.getString("phone"));
                        member.setTo_date(rs.getTimestamp("to_date"));
                        member.setCheck_adm(rs.getInt("check_date"));
                                }
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
        }
        finally
        {
            if (rs != null) try { rs.close(); } catch(SQLException ex) {}
            if (pstmt != null) try { pstmt.close(); } catch(SQLException ex) {}
            if (conn != null) try { conn.close(); } catch(SQLException ex) {}
        }
                return member;
        }
	
	//update Member
 	public void  updateMember(AdminDataBean member)throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;

                try
                {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);
pstmt = conn.prepareStatement("update member set id =?, passwd=?,m_name=?,email=?,phone=?,check_adm=? where id=?");
           
			pstmt.setString(1, member.getId());
			pstmt.setString(2, member.getPasswd());
            		pstmt.setString(3, member.getM_name());
            		pstmt.setString(4, member.getEmail());
            		pstmt.setString(5, member.getPhone());
			pstmt.setInt(6, member.getCheck_adm());
            		pstmt.setString(7, member.getId());

			pstmt.executeUpdate();


                }
                catch(Exception ex)
                {
                ex.printStackTrace();
                }

                finally
                {
                        if(pstmt != null) try { pstmt.close();} catch(SQLException ex){}
                        if(conn != null) try { conn.close();} catch(SQLException ex){}
                }
        }

	//delete Member
	public void deleteMember(String id)throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;

                try
                {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);
                        pstmt = conn.prepareStatement("delete from member where id=?");
                        pstmt.setString(1,id);
                        pstmt.executeUpdate();
                }
                catch(Exception ex)
                {
                ex.printStackTrace();
                }

                finally
                {
                        if(pstmt != null) try { pstmt.close();} catch(SQLException ex){}
                        if(conn != null) try { conn.close();} catch(SQLException ex){}
                }
        }

	//insert member
         public void insertMember(AdminDataBean member) throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;

                try
                {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

pstmt = conn.prepareStatement("insert into member(id,passwd,m_name,phone,email,to_date) values (?,?,?,?,?,?)");
                        pstmt.setString(1,member.getId());
                        pstmt.setString(2,member.getPasswd());
                        pstmt.setString(3,member.getM_name());
                        pstmt.setString(4,member.getPhone());
                        pstmt.setString(5,member.getEmail());
                        pstmt.setTimestamp(6,member.getTo_date());
                        pstmt.executeUpdate();
                }
                catch(Exception ex)
                {
                ex.printStackTrace();
                }
                finally
                {
                        if(pstmt != null) try { pstmt.close();} catch(SQLException ex){}
                        if(conn != null) try { conn.close();} catch(SQLException ex){}
                }
        }

	
	//IPcheck
		   
	public int Ipcheck(String ip) throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;
                ResultSet rs = null;
                int x = -1;

                try
                {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

                        pstmt = conn.prepareStatement("select num from server where ip = ?");
                        pstmt.setString (1,ip);
                        rs = pstmt.executeQuery();

                        if(rs.next())
                        {
                                x = 1;
                        }
                }
                catch(Exception ex)
                {
                   ex.printStackTrace();
                }
                finally
                {
                   if(rs != null) try { rs.close();} catch(SQLException ex){}
                   if(pstmt != null) try { pstmt.close();} catch(SQLException ex){}
                   if(conn != null) try { conn.close();} catch(SQLException ex){}
                }

                return x;
        }

	//smcount
        public int SmCount() throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;
                ResultSet rs = null;

                int x = 0;

                try
                {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

                        pstmt = conn.prepareStatement("select count(*) from sm_info");
                        rs = pstmt.executeQuery();

                        if(rs.next())
                        {
                                x = rs.getInt(1);
                        }
                }

                catch(Exception ex)
                {
                ex.printStackTrace();
                }

                finally
                {
                        if(rs != null) try { rs.close();} catch(SQLException ex){}
                        if(pstmt != null) try { pstmt.close();} catch(SQLException ex){}
                        if(conn != null) try { conn.close();} catch(SQLException ex){}
                }
                return x;
        }
	//sm M&S count
        public int SmmCount() throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;
                ResultSet rs = null;

                int x = 0;

                try
                {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

                     
pstmt = conn.prepareStatement("select count(*)from member,server,sm_info where sm_info.s_num = server.num and sm_info.m_id = member.id");

                        rs = pstmt.executeQuery();

                        if(rs.next())
                        {
                                x = rs.getInt(1);
                        }
                }

                catch(Exception ex)
                {
                ex.printStackTrace();
                }

                finally
                {
                        if(rs != null) try { rs.close();} catch(SQLException ex){}
                        if(pstmt != null) try { pstmt.close();} catch(SQLException ex){}
                        if(conn != null) try { conn.close();} catch(SQLException ex){}
                }
                return x;
        }


	//smlist
	
	public List Smlist(int start, int end)throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;
                ResultSet rs = null;
                List<AdminDataBean> articleList = null;

                 try
               {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

          pstmt = conn.prepareStatement("select sm_info.sm_num,server.name,server.ip,member.id,member.m_name,member.phone,member.email from member,server,sm_info where sm_info.s_num = server.num and sm_info.m_id = member.id order by sm_num asc limit ?,? ");

                        pstmt.setInt(1, start-1);
                        pstmt.setInt(2, end);
                        rs = pstmt.executeQuery();


                        if(rs.next())
                        {
                                articleList = new ArrayList<AdminDataBean>(end);
                                do
                                {
                                        AdminDataBean article = new AdminDataBean();

						article.setId(rs.getString("id"));
						article.setM_name(rs.getString("m_name"));
						article.setPhone(rs.getString("phone"));
						article.setEmail(rs.getString("email"));
						article.setName(rs.getString("name"));
						article.setIp(rs.getString("ip"));
                                                article.setSm_num(rs.getInt("sm_num"));

						
					 articleList.add(article);

                		} while (rs.next());
            		}
        } catch (Exception ex) {
            ex.printStackTrace();
        } finally {if (rs != null) try {rs.close();} catch (SQLException ex) {}
            if (pstmt != null)try {pstmt.close();} catch (SQLException ex) {}
    	    if (conn != null) try { conn.close(); } catch (SQLException ex) {}
        }
        return articleList;
    }
	
	
	//m&s lp check
	 public AdminDataBean MsIpcheck(String ip) throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;
                ResultSet rs = null;
                AdminDataBean member=null;

                try
                {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

                        pstmt = conn.prepareStatement("select num from server where ip = ?");
                        pstmt.setString (1,ip);
                        rs = pstmt.executeQuery();
			
			member = new AdminDataBean();

                        member.setNum(rs.getInt("num"));
		}	
                catch(Exception ex)
                {
                   ex.printStackTrace();
                }
                finally
                {
                   if(rs != null) try { rs.close();} catch(SQLException ex){}
                   if(pstmt != null) try { pstmt.close();} catch(SQLException ex){}
                   if(conn != null) try { conn.close();} catch(SQLException ex){}
                }

                return member;
        }

	//m&s insert
	 public void insertSM(int num, String id) throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;

                try
                {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

		pstmt = conn.prepareStatement("insert into sm_info(m_id,s_num) values (?,?)");
                        pstmt.setString(1,id);
                        pstmt.setInt(2,num);
                        pstmt.executeUpdate();
                }
                catch(Exception ex)
                {
                ex.printStackTrace();
                }
                finally
                {
                        if(pstmt != null) try { pstmt.close();} catch(SQLException ex){}
                        if(conn != null) try { conn.close();} catch(SQLException ex){}
                }
        }
	//m&s serverdelete
	 public void deleteSmserver(int num)throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;

                try
                {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);
                        pstmt = conn.prepareStatement("delete from sm_info where s_num=?");
                        pstmt.setInt(1,num);
                        pstmt.executeUpdate();
                }
                catch(Exception ex)
                {
                ex.printStackTrace();
                }

                finally
                {
                        if(pstmt != null) try { pstmt.close();} catch(SQLException ex){}
                        if(conn != null) try { conn.close();} catch(SQLException ex){}
                }
        }
	
	//s&m member delete
	public void deleteSmMember(String id)throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;

                try
                {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);
                        pstmt = conn.prepareStatement("delete from sm_info where s_id=?");
                        pstmt.setString(1,id);
                        pstmt.executeUpdate();
                }
                catch(Exception ex)
                {
                ex.printStackTrace();
                }

                finally
                {
                        if(pstmt != null) try { pstmt.close();} catch(SQLException ex){}
                        if(conn != null) try { conn.close();} catch(SQLException ex){}
                }
        }
	
	// smDelete
	 public void smDelete(int num)throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;

                try
                {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);
                        pstmt = conn.prepareStatement("delete from sm_info where sm_num=?");
                        pstmt.setInt(1,num);
                        pstmt.executeUpdate();
                }
                catch(Exception ex)
                {
                ex.printStackTrace();
                }

                finally
                {
                        if(pstmt != null) try { pstmt.close();} catch(SQLException ex){}
                        if(conn != null) try { conn.close();} catch(SQLException ex){}
                }
        }
}
