package Monitoring;

import java.sql.*;
import java.util.*;

public class MonitoringDBBean
{
        private final String jdbcUrl = "jdbc:mysql://localhost:3306/project";
        private final String dbId = "project";
        private final String dbpass = "dnjsejrjftm";
				      
	
	
	// server count
	 public int ServerCount(String id) throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;
                ResultSet rs = null;

                int x = 0;

                try
                {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

			pstmt = conn.prepareStatement(
"select count(distinct server.ip) from sm_info,server,result_status where result_status.serverip = server.ip and sm_info.m_id = ? ");
			
			pstmt.setString (1,id);
                        rs = pstmt.executeQuery();

                        if(rs.next())
                        {
                                x = rs.getInt(1);
                        }
                }

                catch(Exception ex)
                {
                ex.printStackTrace();
                }

                finally
                {
                        if(rs != null) try { rs.close();} catch(SQLException ex){}
                        if(pstmt != null) try { pstmt.close();} catch(SQLException ex){}
                        if(conn != null) try { conn.close();} catch(SQLException ex){}
                }
                return x;
        }
                    
	
	//serialcheck
	
        public MonitoringDataBean  serialcheck(String id)throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;
                ResultSet rs = null;
		MonitoringDataBean article = null;


                 try
               {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

 pstmt = conn.prepareStatement(" select distinct result_status.serial from server,result_status,sm_info where result_status.serverip = server.ip and sm_info.s_num = server.num and sm_info.m_id = ? order by result_status.num asc");
			
			pstmt.setString(1, id);
                        rs = pstmt.executeQuery();


                        if(rs.last())
                        {
                        	article = new MonitoringDataBean();
				article.setSerial(rs.getLong("serial"));
            		}
        	} catch (Exception ex) {
            		ex.printStackTrace();
       	 	} finally {if (rs != null) try {rs.close();} catch (SQLException ex) {}
            		if (pstmt != null)try {pstmt.close();} catch (SQLException ex) {}
            		if (conn != null) try { conn.close(); } catch (SQLException ex) {}
        	}
        	return article;
    	}
	
	
	//server status
	public List Status(String id,long serial1)throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;
                ResultSet rs = null;
                List<MonitoringDataBean> articleList1 = null;

                 try
               {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

 pstmt = conn.prepareStatement("select distinct server.name, result_status.serverip,result_status.result_in,result_status.result_out,result_status.serial from server,result_status,sm_info where result_status.serverip = server.ip and sm_info.s_num = server.num and sm_info.m_id = ? and result_status.serial = ? order by  result_status.num asc ");

                        pstmt.setString(1, id);
			pstmt.setLong(2, serial1);

                        rs = pstmt.executeQuery();


                        if(rs.next())
                         {
                                articleList1 = new ArrayList<MonitoringDataBean>();
            				 do
                                {

                                        MonitoringDataBean article1 = new MonitoringDataBean();


                                                article1.setIp(rs.getString("serverip"));
						article1.setResult_in(rs.getInt("result_in"));
						article1.setResult_out(rs.getInt("result_out"));
						article1.setSerial(rs.getLong("serial"));
						article1.setName(rs.getString("name"));
                                                articleList1.add(article1);
				} while (rs.next());
 				                              
                        }
                } catch (Exception ex) {
                        ex.printStackTrace();
                } finally {if (rs != null) try {rs.close();} catch (SQLException ex) {}
                        if (pstmt != null)try {pstmt.close();} catch (SQLException ex) {}
                        if (conn != null) try { conn.close(); } catch (SQLException ex) {}
                }
                return articleList1;
        }
	
	//process check
	public List Sname(String ip,Long serial1)throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;
                ResultSet rs = null;
                List<MonitoringDataBean> articleList1 = null;

                 try
               {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

 pstmt = conn.prepareStatement("select distinct process from result_in where serial = ? and serverip = ? order by num asc");

                        pstmt.setLong(1, serial1);
			pstmt.setString(2,ip);
                        rs = pstmt.executeQuery();

			if(rs.next())
                         {
                                articleList1 = new ArrayList<MonitoringDataBean>();
                                         do
                                {

                                        MonitoringDataBean article1 = new MonitoringDataBean();


                                                article1.setProcess(rs.getString("process"));
                                                
                                                articleList1.add(article1);
                                } while (rs.next());
                        }
                } catch (Exception ex) {
                        ex.printStackTrace();
                } finally {if (rs != null) try {rs.close();} catch (SQLException ex) {}
                        if (pstmt != null)try {pstmt.close();} catch (SQLException ex) {}
                        if (conn != null) try { conn.close(); } catch (SQLException ex) {}
                }
                return articleList1;
        }

	//process in count check	
	public int Processchk(String ip,Long serial1,String name)throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;
                ResultSet rs = null;
                MonitoringDataBean article = null;
		int check = 0;

                 try
               {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

 pstmt = conn.prepareStatement("select count from result_in where serverip = ? and serial = ?  and process = ?");

                        pstmt.setString(1, ip);
			pstmt.setLong(2, serial1);
			pstmt.setString(3, name);
                        rs = pstmt.executeQuery();


                        if(rs.last())
                        {
                                check = rs.getInt("count");
                        }
                } catch (Exception ex) {
                        ex.printStackTrace();
                } finally {if (rs != null) try {rs.close();} catch (SQLException ex) {}
                        if (pstmt != null)try {pstmt.close();} catch (SQLException ex) {}
                        if (conn != null) try { conn.close(); } catch (SQLException ex) {}
                }
                return check;
        }


	//process out count check
        public int ProcessOutchk(String ip,Long serial1,String name)throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;
                ResultSet rs = null;
                MonitoringDataBean article = null;
                int check = 0;

                 try
               {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

 pstmt = conn.prepareStatement("select status from result_out where serverip = ? and serial = ?  and process = ?"
);

                        pstmt.setString(1, ip);
                        pstmt.setLong(2, serial1);
                        pstmt.setString(3, name);
                        rs = pstmt.executeQuery();


                        if(rs.last())
                        {
                                check = rs.getInt("status");
                        }
                } catch (Exception ex) {
                        ex.printStackTrace();
                } finally {if (rs != null) try {rs.close();} catch (SQLException ex) {}
                        if (pstmt != null)try {pstmt.close();} catch (SQLException ex) {}
                        if (conn != null) try { conn.close(); } catch (SQLException ex) {}
                }
                return check;
        }

	//sleep
	public void sleep1()throws Exception
        {
               try
               {
               	Thread.sleep(2000);         
               } catch (Exception ex) {
                        ex.printStackTrace();
               }
        }
	
	public MonitoringDataBean ServerInfo(String ip)throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;
                ResultSet rs = null;
                MonitoringDataBean  article = null;

                try
                {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

                        pstmt = conn.prepareStatement("select * from server where ip = ?");
                        pstmt.setString(1,ip);
                        rs = pstmt.executeQuery();

                        if(rs.next())
                        {
                                article = new MonitoringDataBean ();
                                article.setIp(rs.getString("ip"));
                                article.setStatus_check(rs.getInt("status_check"));
                                article.setRpass(rs.getString("rpass"));
                                article.setName(rs.getString("name"));
                        }
                }

                catch(Exception ex)
                {
                ex.printStackTrace();
                }

                finally
                {
                        if(rs != null) try { rs.close();} catch(SQLException ex){}
                        if(pstmt != null) try { pstmt.close();} catch(SQLException ex){}
                        if(conn != null) try { conn.close();} catch(SQLException ex){}
                }
               return article;
        }
	
	//result list
	
	public List resultList(String name,String ip,int start, int end)throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;
                ResultSet rs = null;
                List<MonitoringDataBean> articleList = null;

                 try
               {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

 pstmt = conn.prepareStatement("select result_in.serverip,result_in.count,result_out.process,result_out.status,result_in.serial from result_in,result_out where result_in.serial = result_out.serial and result_in.serverip = result_out.serverip and result_in.process = result_out.process and result_in.serverip = ? and result_in.process = ? order by result_in.num desc limit ?,?");
		
			pstmt.setString(1,ip);
                        pstmt.setString(2,name);
			pstmt.setInt(3, start-1);
                        pstmt.setInt(4, end);

                        rs = pstmt.executeQuery();

                        if(rs.next())
                         {
                                articleList = new ArrayList<MonitoringDataBean>(end);
                                         do
                                {

                                        MonitoringDataBean article = new MonitoringDataBean();
						
                                                article.setSerial(rs.getLong("serial"));
						article.setProcess(rs.getString("process"));
						article.setCount(rs.getInt("count"));
						article.setIp(rs.getString("serverip"));
						article.setStatus(rs.getInt("status"));
                                                articleList.add(article);

                                } while (rs.next());
                        }
                } catch (Exception ex) {
                        ex.printStackTrace();
                } finally {if (rs != null) try {rs.close();} catch (SQLException ex) {}
                        if (pstmt != null)try {pstmt.close();} catch (SQLException ex) {}
                        if (conn != null) try { conn.close(); } catch (SQLException ex) {}
                }
                return articleList;
        }
	
	//result count
	
	 public int resultCount(String name,String ip)throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;
                ResultSet rs = null;
                MonitoringDataBean article = null;
                int x = 0;

                 try
               {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

	pstmt = conn.prepareStatement("select count(*) from result_in where process = ? and serverip = ?");

                        pstmt.setString(1, name);
                        pstmt.setString(2, ip);
                        rs = pstmt.executeQuery();
			
			if(rs.next())
                        {
                                x = rs.getInt(1);
                        }
                }

                catch(Exception ex)
                {
                ex.printStackTrace();
                }

                finally
                {
                        if(rs != null) try { rs.close();} catch(SQLException ex){}
                        if(pstmt != null) try { pstmt.close();} catch(SQLException ex){}
                        if(conn != null) try { conn.close();} catch(SQLException ex){}
                }
                return x;
        }
	
	//firewall_accept list
	public List fireAcceptList(String ip,int start, int end)throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;
                ResultSet rs = null;
                List<MonitoringDataBean> articleList = null;

                 try
               {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

 pstmt = conn.prepareStatement("select * from firewall_accept where host_ip = ? order by num asc limit ?,?");

                        pstmt.setString(1,ip);
                        pstmt.setInt(2, start-1);
                        pstmt.setInt(3, end);

                        rs = pstmt.executeQuery();

                        if(rs.next())
                         {
                                articleList = new ArrayList<MonitoringDataBean>();
                                         do
                                {

                                        MonitoringDataBean article = new MonitoringDataBean();
						article.setNum(rs.getInt("num"));
                                                article.setHost_ip(rs.getString("host_ip"));
                                                article.setProto(rs.getString("proto"));
                                                article.setS_ip(rs.getString("s_ip"));
						article.setS_port(rs.getString("s_port"));
						article.setD_port(rs.getString("d_port"));
                                               
                                                articleList.add(article);

                                } while (rs.next());
                        }
                } catch (Exception ex) {
                        ex.printStackTrace();
                } finally {if (rs != null) try {rs.close();} catch (SQLException ex) {}
                        if (pstmt != null)try {pstmt.close();} catch (SQLException ex) {}
                        if (conn != null) try { conn.close(); } catch (SQLException ex) {}
                }
                return articleList;
        }
	
	//firewall accept count
	 public int fireAcceptCount(String ip)throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;
                ResultSet rs = null;
                MonitoringDataBean article = null;
                int x = 0;

                 try
               {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

        pstmt = conn.prepareStatement("select count(*) from firewall_accept where host_ip = ?");

                        pstmt.setString(1, ip);
                        rs = pstmt.executeQuery();

                        if(rs.next())
                        {
                                x = rs.getInt(1);
                        }
                }

                catch(Exception ex)
                {
                ex.printStackTrace();
                }

                finally
                {
                        if(rs != null) try { rs.close();} catch(SQLException ex){}
                        if(pstmt != null) try { pstmt.close();} catch(SQLException ex){}
                        if(conn != null) try { conn.close();} catch(SQLException ex){}
                }
                return x;
        }
	
	 //firewall deny count
         public int fireDenyCount(String ip)throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;
                ResultSet rs = null;
                MonitoringDataBean article = null;
                int x = 0;

                 try
               {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

        pstmt = conn.prepareStatement("select count(*) from firewall_deny where host_ip = ?");

                        pstmt.setString(1, ip);
                        rs = pstmt.executeQuery();

                        if(rs.next())
                        {
                                x = rs.getInt(1);
                        }
                }

                catch(Exception ex)
                {
                ex.printStackTrace();
                }

                finally
                {
                        if(rs != null) try { rs.close();} catch(SQLException ex){}
                        if(pstmt != null) try { pstmt.close();} catch(SQLException ex){}
                        if(conn != null) try { conn.close();} catch(SQLException ex){}
                }
                return x;
        }
	
	//firewall_deny list
        public List fireDenyList(String ip,int start, int end)throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;
                ResultSet rs = null;
                List<MonitoringDataBean> articleList = null;

                 try
               {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

 pstmt = conn.prepareStatement("select * from firewall_deny where host_ip = ? order by num asc limit ?,?");

                        pstmt.setString(1,ip);
                        pstmt.setInt(2, start-1);
                        pstmt.setInt(3, end);

                        rs = pstmt.executeQuery();

                        if(rs.next())
                         {
                                articleList = new ArrayList<MonitoringDataBean>();
                                         do
                                {

                                        MonitoringDataBean article = new MonitoringDataBean();

						article.setNum(rs.getInt("num"));
                                                article.setHost_ip(rs.getString("host_ip"));
                                                article.setProto(rs.getString("proto"));
                                                article.setS_ip(rs.getString("s_ip"));
                                                article.setS_port(rs.getString("s_port"));
                                                article.setD_port(rs.getString("d_port"));

                                                articleList.add(article);

                                } while (rs.next());
                        }
                } catch (Exception ex) {
		            ex.printStackTrace();
                } finally {if (rs != null) try {rs.close();} catch (SQLException ex) {}
                        if (pstmt != null)try {pstmt.close();} catch (SQLException ex) {}
                        if (conn != null) try { conn.close(); } catch (SQLException ex) {}
                }
                return articleList;
        }

	//insert firewall
	public void insertfirewallAccept(MonitoringDataBean member) throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;

                try
                {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

pstmt = conn.prepareStatement("insert into firewall_accept(host_ip,proto,s_ip,s_port,d_port) values (?,?,?,?,?)");

                        pstmt.setString(1,member.getHost_ip());
                        pstmt.setString(2,member.getProto());
                        pstmt.setString(3,member.getS_ip());
                        pstmt.setString(4,member.getS_port());
			pstmt.setString(5,member.getD_port());


                        pstmt.executeUpdate();
                }
                catch(Exception ex)
                {
                ex.printStackTrace();
                }
                finally
                {
                        if(pstmt != null) try { pstmt.close();} catch(SQLException ex){}
                        if(conn != null) try { conn.close();} catch(SQLException ex){}
                }
        }
	
	//firewall_accept delete
	
	 public void fireAcceptDelete(int num)throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;

                try
                {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);
                        pstmt = conn.prepareStatement("delete from firewall_accept where num = ?");
                        pstmt.setInt(1,num);
                        pstmt.executeUpdate();
                }
                catch(Exception ex)
                {
                ex.printStackTrace();
                }

                finally
                {
                        if(pstmt != null) try { pstmt.close();} catch(SQLException ex){}
                        if(conn != null) try { conn.close();} catch(SQLException ex){}
                }
        }
	
	 //insert firewall deny
        public void insertfirewalldeny(MonitoringDataBean member) throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;

                try
                {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

pstmt = conn.prepareStatement("insert into firewall_deny(host_ip,proto,s_ip,s_port,d_port) values (?,?,?,?,?)");

                        pstmt.setString(1,member.getHost_ip());
                        pstmt.setString(2,member.getProto());
                        pstmt.setString(3,member.getS_ip());
                        pstmt.setString(4,member.getS_port());
                        pstmt.setString(5,member.getD_port());


                        pstmt.executeUpdate();
                }
                catch(Exception ex)
                {
                ex.printStackTrace();
                }
                finally
                {
                        if(pstmt != null) try { pstmt.close();} catch(SQLException ex){}
                        if(conn != null) try { conn.close();} catch(SQLException ex){}
                }
        }
	
	//firewall_deny delete

         public void fireDenyDelete(int num)throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;

                try
                {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);
                        pstmt = conn.prepareStatement("delete from firewall_deny where num = ?");
                        pstmt.setInt(1,num);
                        pstmt.executeUpdate();
                }
                catch(Exception ex)
                {
                ex.printStackTrace();
                }

                finally
                {
                        if(pstmt != null) try { pstmt.close();} catch(SQLException ex){}
                        if(conn != null) try { conn.close();} catch(SQLException ex){}
                }
        }
	
	   //server status
        public List comStatus(String id,long serial1)throws Exception
        {
                Connection conn = null;
                PreparedStatement pstmt = null;
                ResultSet rs = null;
                List<MonitoringDataBean> articleList1 = null;

                 try
               {
                        Class.forName("org.gjt.mm.mysql.Driver");
                        conn = DriverManager.getConnection(jdbcUrl,dbId,dbpass);

 pstmt = conn.prepareStatement("select distinct result_idle.process,result_idle.status,result_idle.count,result_idle.data,serial from server,result_idle,sm_info where server.ip = result_idle.serverip and sm_info.s_num = server.num and sm_info.m_id = ? and result_idle.serial = ? order by  result_idle.num asc ");

                        pstmt.setString(1, id);
                        pstmt.setLong(2, serial1);

                        rs = pstmt.executeQuery();


                        if(rs.next())
                         {
                                articleList1 = new ArrayList<MonitoringDataBean>();
                                         do
                                {

                                        MonitoringDataBean article1 = new MonitoringDataBean();


                                                article1.setProcess(rs.getString("process"));
                                                article1.setStatus1(rs.getString("status"));
                                                article1.setCount(rs.getInt("count"));
                                                article1.setData(rs.getString("data"));
                                                article1.setSerial(rs.getLong("serial"));
                                                articleList1.add(article1);
                                } while (rs.next());

                        }
                } catch (Exception ex) {
                        ex.printStackTrace();
                } finally {if (rs != null) try {rs.close();} catch (SQLException ex) {}
                        if (pstmt != null)try {pstmt.close();} catch (SQLException ex) {}
                        if (conn != null) try { conn.close(); } catch (SQLException ex) {}
                }
                return articleList1;
        }


}
