package scengine;
import java.net.*;
import java.io.*;
import java.util.*;

public class SetManager
{
	String scLocation = "/usr/local/scengine/shell/sc_shell";
	
	public int userAdd(String user,String passwd,String serverIp)
	{
		String runScript=scLocation + " --menu=userset --submenu=set_useradd --user=" + user + " --passwd=" + passwd;
		ProcessData pD = doScript(runScript,serverIp);
		return pD.resultNum;
	}
	public int userDel(String user,String serverIp)
	{
		String runScript=scLocation + " --menu=userset --submenu=set_userdel --user=" + user;
		ProcessData pD = doScript(runScript,serverIp);
		return pD.resultNum;
	}
	public int mailUserAdd(String mailuser,String user,String serverIp)
	{
		String runScript=scLocation + " --menu=mailset --submenu=mail_useradd --mail_user=" + mailuser +" --user=" + user;
		ProcessData pD = doScript(runScript,serverIp);
		return pD.resultNum;
	}
	public int mailUserDel(String mailuser,String user,String serverIp)
	{
		String runScript=scLocation + " --menu=mailset --submenu=mail_userdel --mail_user=" + mailuser +" --user=" + user;
		ProcessData pD = doScript(runScript,serverIp);
		return pD.resultNum;
	}
	public int webHostAdd(String domain,String serverIp)
	{
		String runScript=" --menu=webset --submenu=web_hostadd --domain=" + domain;
		ProcessData pD = doScript(runScript,serverIp);
		return pD.resultNum;
	}
	public int webHostDel(String domain,String serverIp)
	{
		String runScript=" --menu=webset --submenu=web_hostdel --domain=" + domain;
		ProcessData pD = doScript(runScript,serverIp);
		return pD.resultNum;
	}
	public String[] userList(String serverIp)
	{
		String runScript="cat /etc/passwd";
		ProcessData processData = doScript(runScript,serverIp);
		String aaa=new String(processData.resultCommand);	
		String[] resultData =  aaa.split("\n");
		
		return resultData;
		
	}
	public String[] mailUserList(String serverIp)
	{
		String runScript="cat /etc/mail/virtusertable";
		ProcessData processData = doScript(runScript,serverIp);
		String aaa=new String(processData.resultCommand);
		String[] resultData =  aaa.split("\n");
		return resultData;
		
	}
	public String[] webHostList(String serverIp)
    {
        String runScript="ls -d  /www/*";
        ProcessData processData = doScript(runScript,serverIp);
        String aaa=new String(processData.resultCommand);
        String[] resultData =  aaa.split("\n");
        return resultData;

    }
	private ProcessData doScript(String runScript,String serverIp)
	{
		ProcessData processData = new ProcessData(runScript);		        
		long serialNumber = new Date().getTime();
		processData.serialNumber = serialNumber;
		processData.serverIp = serverIp ;
		processData.checkType= "Command";
	
		Socket socket=null;
		 try{
            socket = new Socket("127.0.0.1",9003);
            ObjectOutputStream out = new ObjectOutputStream(socket.getOutputStream());
            ObjectInputStream in = new ObjectInputStream(socket.getInputStream());
       //     System.out.println("Ai write");
            out.writeObject(processData);
            Object obj = in.readObject();
            processData = (ProcessData)obj;
            System.out.println(processData.resultNum);

        }catch(Exception e){
            e.printStackTrace();
        }finally{
			try{
				socket.close();
			}catch(Exception e){
				e.printStackTrace();
			}
		}
		 return processData;

	}
}

		 
		
		
